--
--	Package File Template
--
--	Purpose: This package defines supplemental types, subtypes, 
--		 constants, and functions 
--
--   To use any of the example code shown below, uncomment the lines and modify as necessary
--

library IEEE;
use IEEE.STD_LOGIC_1164.all;

package Global is

-- Konstanten
-- constant <constant_name>		: time := <time_unit> ns;
-- constant <constant_name>		: integer := <value;

constant DATABUS_WIDTH: integer := 8;
constant MSB_DATA:      integer := DATABUS_WIDTH - 1;

-- allg. Datentypen
type TDataBus is record
  Data: STD_LOGIC_VECTOR(MSB_DATA downto 0); -- 8 Bit Datenbus
end record;

-- Interface zum FTDI-Chip
type TFTDIChipStat is record
  --RXF:        STD_LOGIC;                         -- RX Flag, FTDI hat Daten
  TXE:        STD_LOGIC;                         -- TX Enable, Sendepuffer noch nicht voll
end record;

type TFTDIChipCtrl is record
  RD:         STD_LOGIC;                         -- Read vom FTDI
  WR:         STD_LOGIC;                         -- Write zum FTDI
  OE:         STD_LOGIC;                         -- Output Enable
end record;

-- Interface zur Main-Entitt
type TFTDIMainStat is record
  RDY:        STD_LOGIC;                         -- Ready (for transmit Data)
end record;

type TFTDIMainCtrl is record
  STA:        STD_LOGIC;                         -- Start (von Main) Senden
end record;

constant HOCHOHMIG: TDataBus := (Data => (others => 'Z')); 
constant ALLESNULL: TDataBus := (Data => (others => '0')); 
constant ALLESEINS: TDataBus := (Data => (others => '1')); 

end Global;

package body Global is
-- bisher noch nichts
end Global;
