----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    08:41:03 04/02/2012 
-- Design Name: 
-- Module Name:    MainController - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
----------------------------------------------------------------------------------
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use Work.Global.ALL;

--********************************************************************************
--********************************************************************************
--********************************************************************************
entity MainController is Port ( 
  CLK: in  std_logic;
  RST: in  std_logic;
  STA: in  std_logic;

  --RXF: in  std_logic;
  TXE: in  std_logic;
  
  RD: out  std_logic;
  WR: out  std_logic;
  OE: out  std_logic;

  --FTDIData: inout TDataBus);
  FTDIData: inout std_logic_vector(7 downto 0));
end MainController;
--///////////////////////////////////////////////////////////////////
architecture Behavioral of MainController is
  signal FTDIChipStatus:  TFTDIChipStat;
  signal FTDIChipCtrl:    TFTDIChipCtrl;
  signal FTDIMainStatus:  TFTDIMainStat;
  signal FTDIMainCtrl:    TFTDIMainCtrl;
  ---------------------------------------------------------
  COMPONENT FTDI PORT (
    CLK:          IN std_logic;
    RST:          IN std_logic;
    ChipStatus:   IN TFTDIChipStat;
    ChipCtrl:    OUT TFTDIChipCtrl;
    MainStatus:  OUT TFTDIMainStat;
    MainCtrl:     IN TFTDIMainCtrl);
  END COMPONENT;
  ---------------------------------------------------------
begin
	
  --FTDIChipStatus.RXF <= RXF;
  FTDIChipStatus.TXE <= TXE;
  
  RD <= FTDIChipCtrl.RD;
  WR <= FTDIChipCtrl.WR;
  OE <= FTDIChipCtrl.OE;
  
  FTDIMainCtrl.STA <= STA;

  --with FTDIMainStatus.RDY select FTDIData <= (Data => x"55") when '1', HOCHOHMIG when others;
  with FTDIMainStatus.RDY select FTDIData <= x"55" when '1', (others=>'Z') when others;
  
  I_FTDI: FTDI PORT MAP
  ( 
    CLK => CLK, RST => RST,
    ChipStatus => FTDIChipStatus, ChipCtrl => FTDIChipCtrl,
    MainStatus => FTDIMainStatus, MainCtrl => FTDIMainCtrl
  );
end Behavioral;
--********************************************************************************
--********************************************************************************
--********************************************************************************